unit Ugraph;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, math, ExtDlgs ;

type
  TForm1 = class(TForm)
    Button1: TButton;
    pb: TPaintBox;
    Image1: TImage;
    Edit1: TEdit;
    Button2: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
uses
  UTransForm ;

procedure TForm1.Button1Click(Sender: TObject);
var
  ptOrgCenter, ptTarCenter, ptc : TPoint ;
  pta : array[0..3] of TPoint ;
  ba : array[0..3] of integer ;
  i : integer ;
  bmp : TBitmap ;
  dbTheta : Double ;
begin
  ptOrgCenter.x:=Image1.Picture.Width div 2 ;
  ptOrgCenter.y:=Image1.Picture.Height div 2 ;

  dbTheta:=StrToFloat(Edit1.Text) ;
  pta[0]:=RotateXY(dbTheta,Point(0,0)) ;
  pta[1]:=RotateXY(dbTheta,Point(Image1.Picture.Width-1,0)) ;
  pta[2]:=RotateXY(dbTheta,Point(0,Image1.Picture.Height-1)) ;
  pta[3]:=RotateXY(dbTheta,Point(Image1.Picture.Width-1,Image1.Picture.Height-1)) ;

  bmp:=TBitmap.Create ;
  bmp.PixelFormat:=pf24bit ;
  bmp.Canvas.Brush.Color:=clBtnFace ;

  for i:=0 to 3 do
    ba[i]:=pta[i].x ;

  bmp.width:=MaxIntValue(ba)-MinIntValue(ba) ;

  for i:=0 to 3 do
    ba[i]:=pta[i].y ;

  bmp.Height:=MaxIntValue(ba)-MinIntValue(ba) ;

  ptc:=RotateXY(dbTheta,Point(Image1.Picture.Width div 2,Image1.Picture.Height div 2)) ;

  ptTarCenter.x:=bmp.Width div 2 ;
  ptTarCenter.y:=bmp.Height div 2 ;

  pta[0].x:=pta[0].x+ptTarCenter.x-ptc.x ;
  pta[0].y:=pta[0].y+ptTarCenter.y-ptc.y ;
  pta[1].x:=pta[1].x+ptTarCenter.x-ptc.x ;
  pta[1].y:=pta[1].y+ptTarCenter.y-ptc.y ;
  pta[2].x:=pta[2].x+ptTarCenter.x-ptc.x ;
  pta[2].y:=pta[2].y+ptTarCenter.y-ptc.y ;

  PlgBlt(bmp.Canvas.Handle,
         pta,
         Image1.Canvas.Handle,
         0,
         0,
         image1.Picture.Width-1,
         image1.Picture.Height-1,
         0,
         0,
         0
         ) ;

  pb.Canvas.Draw(0,0,bmp) ;
  bmp.SaveToFile(ExtractFilePath(Application.Name)+'111.bmp') ;
  bmp.free ;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then
    Image1.Picture.LoadFromFile(OpenPictureDialog1.FileName) ;
end;

end.
